Loading...
Searching...
No Matches
dolfin::DiscreteOperators Class Reference

Discrete gradient operators providing derivatives of functions. More...

`#include <DiscreteOperators.h>`

## Static Public Member Functions

static std::shared_ptr< GenericMatrix > | build_gradient (const FunctionSpace &V0, const FunctionSpace &V1)

## Detailed Description

Discrete gradient operators providing derivatives of functions.

This class computes discrete gradient operators (matrices) that map derivatives of finite element functions into other finite element spaces. An example of where discrete gradient operators are required is the creation of algebraic multigrid solvers for H(curl) and H(div) problems. NOTE: This class is highly experimental and likely to change. It will eventually be expanded to provide the discrete curl and divergence.

## Member Function Documentation

## build_gradient()

std::shared_ptr< GenericMatrix > DiscreteOperators::build_gradient | ( | const FunctionSpace & | V0,
|  | const FunctionSpace & | V1 )

static

Build the discrete gradient operator A that takes a (P1, nodal Lagrange) to (lowest order Nedelec), i.e. v = Aw. V0 is the H(curl) space, and V1 is the P1 Lagrange space.

Parameters

  [in] | V0 | (FunctionSpace&) H(curl) space
  [in] | V1 | (FunctionSpace&) P1 Lagrange space

Returns
  GenericMatrix

The documentation for this class was generated from the following files:

- /build/dolfin-wwk1CC/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/fem/DiscreteOperators.h
- /build/dolfin-wwk1CC/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/fem/DiscreteOperators.cpp